const sales = require('../model/sale');

class DeliveryController {
  /**
   * @returns versão do monitoramento
   */
  varsao() {
    return '0.0.1';
  }

  async getAssistantDeliveryList(data) {
    const vendas = [];
    let delivery = [];
    if(!data || !data.CDFILIAL) {
      delivery = await sales.getDeliveryMonitoring();
    } else {
      delivery = await sales.getDelivery(data);
    }

    // Não existe nenhum pedido pendente
    if (delivery.rows.length === 0) {
      const filial = await sales.getFilial();
      filial.rows.forEach((element) => {
        vendas.push({
          id: element[0],
          delivery: true,
        });
      });
    } else {
      delivery.rows.forEach((element) => {
        vendas.push({
          id: element[0],
          loja: element[5],
          venda: element[3],
          data: element[2],
          delivery: false,
          message: '',
        });
      });
    }
    return vendas;
  }
}

module.exports = new DeliveryController();
