import { Modal, ModalService } from '@zeedhi/common';

import { SocketEvent } from '@/socket/socket-event';
import {
  Config,
  IDictionary,
  IEventParam,
  Metadata,
} from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';
import { io, Socket } from 'socket.io-client';

export class HistoricoController {
  public socket?: Socket;

  public title: any;

  private fullscreenModal!: Modal;

  public async createFullscreenModal() {
    this.fullscreenModal = await ModalService.createFromJson('historico', true);
  }

  public destroyFullscreenModal() {
    this.fullscreenModal?.destroy();
  }

  public openFullscreenModal(row:any) {
    console.warn('row:', row);
    this.fullscreenModal.show();
  }

  public closeFullscreenModal() {
    console.log('Modal');
    this.fullscreenModal.hide();
  }

  /**
   * Método executado quando o grid é criado
   */
  public gridMounted({ component }: IEventParam<TekGrid>) {
    component.datasource.get();
    // // inicializa o socket
    // this.socket = io(Config.endPoint);
    // console.warn('Ok', component);
    // this.socket.off(SocketEvent.CONNECTION)
    //   .emit('updaterHistorico', {
    //     slave: false,
    //   });

    // this.socket.off(SocketEvent.CONNECTION)
    //   .on('updaterHistorico', async (branc: IDictionary) => {
    //     console.warn(branc);
    //     await component.datasource.updateData(branc.message.data);
    //     await component.datasource.get();
    //   });
  }

  public async gridCellClickUpdater({ row } : any) {
    const grid = Metadata.getInstance<TekGrid>('gridHistorico');
    this.socket = io(Config.endPoint);
    this.socket.off(SocketEvent.CONNECTION)
      .emit('updaterHistorico', {
        slave: false,
        dados: {
          IDUPDATERSISTEMAS: row.IDUPDATERSISTEMAS,
          CDFILIAL: row.CDFILIAL,
          IDUPDATER: row.IDUPDATER,
        },
      });

    this.socket.off(SocketEvent.CONNECTION)
      .on('updaterHistorico', async (branc: IDictionary) => {
        grid.datasource.updateData(branc.message.data);
      });
	}

  /**
   * Método executado logo antes do grid ser destruído
   */
  public gridBeforeDestroy() {

  }
}
